function path = A_star_search(map,MAX_X,MAX_Y)
%%
%This part is about map/obstacle/and other settings
    %pre-process the grid map, add offset
    size_map = size(map,1);
    Y_offset = 0;
    X_offset = 0;
    
    %Define the 2D grid map array.
    %Obstacle=-1, Target = 0, Start=1
    MAP=2*(ones(MAX_X,MAX_Y));
    
    %Initialize MAP with location of the target
    xval=floor(map(size_map, 1)) + X_offset;
    yval=floor(map(size_map, 2)) + Y_offset;
    xTarget=xval;
    yTarget=yval;
    MAP(xval,yval)=0;
    
    %Initialize MAP with location of the obstacle
    for i = 2: size_map-1
        xval=floor(map(i, 1)) + X_offset;
        yval=floor(map(i, 2)) + Y_offset;
        MAP(xval,yval)=-1;
    end 
    
    %Initialize MAP with location of the start point
    xval=floor(map(1, 1)) + X_offset;
    yval=floor(map(1, 2)) + Y_offset;
    xStart=xval;
    yStart=yval;
    MAP(xval,yval)=1;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %LISTS USED FOR ALGORITHM
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %OPEN LIST STRUCTURE
    %--------------------------------------------------------------------------
    %IS ON LIST 1/0 |X val |Y val |Parent X val |Parent Y val |h(n) |g(n)|f(n)|
    %--------------------------------------------------------------------------
    OPEN=[];
    %CLOSED LIST STRUCTURE
    %--------------
    %X val | Y val |
    %--------------
    % CLOSED=zeros(MAX_VAL,2);
    CLOSED=[];

    %Put all obstacles on the Closed list
    k=1;%Dummy counter
    for i=1:MAX_X
        for j=1:MAX_Y
            if(MAP(i,j) == -1)
                CLOSED(k,1)=i;
                CLOSED(k,2)=j;
                k=k+1;
            end
        end
    end
    CLOSED_COUNT=size(CLOSED,1);
    %set the starting node as the first node
    xNode=xval;
    yNode=yval;
    OPEN_COUNT=1;
    goal_distance=distance(xNode,yNode,xTarget,yTarget);
    path_cost=0;
    OPEN(OPEN_COUNT,:)=insert_open(xNode,yNode,xNode,yNode,goal_distance,path_cost,goal_distance);
    OPEN(OPEN_COUNT,1)=0;
    CLOSED_COUNT=CLOSED_COUNT+1;
    CLOSED(CLOSED_COUNT,1)=xNode;
    CLOSED(CLOSED_COUNT,2)=yNode;
    NoPath=1;

%%
%This part is your homework
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% START ALGORITHM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    next=MotionModel();
    open=[xStart yStart xStart yStart 0 0 0];%IS ON LIST 1/0 |X val |Y val |Parent X val |Parent Y val |h(n) |g(n)|f(n)|
    close=[];%用于存储搜索的节点信息
    findFlag=false;%目标发现标志
    Nstart = [xStart yStart];
    NTarget = [xTarget yTarget];
    while ~findFlag %发现目标搜索终止 
        
      %如果没有open列表中没有点了，而且还没有找到目标点，则找不到路径。  
      if isempty(open(:,1)) 
          disp('No path to goal!!');
          path=[];
          return; 
      end
      %根据f(n)构建优先队列
      [Y,I] = sort(open(:,7));
      open=open(I,:);
      
      %目标判断
      if ((open(1,1) == xTarget)&&(open(1,2) == yTarget))  %判断优先队列弹出的点是不是目标点
          disp('Find Goal!!');
          %将目标节点移至close的头
          close=[open(1,:);close];
          open(1,:)=[];
          findFlag=true;
          break;
      end
      
      for in=1:length(next(:,1))
          %计算相邻节点的位置和成本
          Ncurrent=[open(1,1)+next(in,1) open(1,2)+next(in,2)];%搜索邻居
          %F(n)= G(n) + H(n);
          %open(1,6)为父节点的g(n)
          Ncurrent_G = open(1,6)+next(in,3);
          Ncurrent_H = h(Ncurrent(1:2),NTarget);
          Ncurrent_F =Ncurrent_G + Ncurrent_H;
          %是否越过边界
          if ((Ncurrent(1)==0)||(Ncurrent(1)==MAX_X+1)||(Ncurrent(2)==0)||(Ncurrent(2)==MAX_Y+1))
              continue; 
          end
          %相邻节点是否为障碍物，则查找下一个节点
          if ((MAP(Ncurrent(1),Ncurrent(2))==-1))
              continue; 
          end
          
          %在打开和关闭列表中搜索Ncurrent
          [flag, targetInd]=FindList(Ncurrent,open);
 
          if flag==1 %如果在open列表上,注意是同一个节点的两个不同路径的估价值
              if Ncurrent_F<open(targetInd,7) %如果新得到的cost小于open列表中的cost值
                  open(targetInd,7)=Ncurrent_F;%更新权重，和父节点
                  open(targetInd,3)=open(1,1);
                  open(targetInd,4)=open(1,2);
              end
          else
              open=[open;[Ncurrent open(1,1) open(1,2) Ncurrent_H Ncurrent_G Ncurrent_F]];
          end
      end
 
      %相邻节点计算出的打开节点移动到关闭节点
      if findFlag==false
          close=[close; open(1,:)];
          open(1,:)=[];
      end
     
    end %End of While Loop
    
    %Once algorithm has run The optimal path is generated by starting of at the
    %last node(if it is the target node) and then identifying its parent node
    %until it reaches the start node.This is the optimal path
    
    %
    %How to get the optimal path after A_star search?
    %please finish it
    %
    
   path = GetPath(close,Nstart);
   
    function next=MotionModel()
    %到相邻节点的运动模型通过更改此参数，可以指定机器人的运动
    % [x y cost]
    %逆时针
    next=[
          1 0 1 
          1 -1 sqrt(2)
          0 -1 1
          -1 -1 sqrt(2)
          -1 0 1
          -1 1 sqrt(2)
          0 1 1
          1 1 sqrt(2)
         ];
    end
    function result=h(a,b)
        %启发式函数

        %result=norm(a-b);欧式距离
        %result=abs(b(1)-a(1))+abs(b(2)-a(2));%曼哈顿距离
        dx = abs(b(1)-a(1));
        dy = abs(b(2)-a(2));
        result=dx+dy+(sqrt(2)-2)*min(dx,dy);
    end
    function [flag, targetInd]=FindList(m,open)
        targetInd=0;
        %是否在open数组中
        if ~isempty(open)
            for io=1:length(open(:,1))
                if ((open(io,1)==m(1))&&(open(io,2)==m(2)))
                    flag=1;
                    targetInd=io;
                    return;
                end
            end
        end
        flag=0;return;
    end
    function path=GetPath(close,Nstart)
    %获取从开始到目标的坐标列表的功能
    InT=1;%目标在关闭列表的顶部
    path=[];
    while 1
        path=[path; close(InT,1:2)];

        %是否已索引到起点
        if ((close(InT,1)==Nstart(1))&&(close(InT,2)==Nstart(2)))
            break;
        end
        %在close中查找父节点
        for InC=1:length(close(:,1))
            if ((close(InC,1)==close(InT,3))&&(close(InC,2)==close(InT,4)))
                InT=InC;
                break;
            end
        end
    end

    end
end
